<!DOCTYPE html>
<html>

<head>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gEleFirstName = $('#inp-first-name');
        var gEleEmail = $('#inp-email');
        var gElePassword = $('#inp-password');
        const gEleConfirmPW = $('#inp-confirm-password');
        var gEleAcceptCheck = $('#check-confirm-accept');

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        $(document).ready(function () {
            $("#btn-sign-up").on("click", function (event) {
                event.preventDefault();
                onBtnSignUpClick();
            })
        });
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onBtnSignUpClick() {
            //b1 thu thập dữ liệu
            var vUserObj = {
                firstname: "",
                email: "",
                password: "",
                confirmpassword: "",
                isAccept: false
            }
            debugger;
            getFormInputData(vUserObj);
            console.log(vUserObj);
            //b2: validate
            var isValidate = validateInput(vUserObj)
            if (isValidate) {
                //b3: hiển thi
                showUserInfo(vUserObj);
            }
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm thu thập data login
        function getFormInputData(paramUserDataObj) {
            paramUserDataObj.firstname = $('#inp-first-name').val().trim();
            paramUserDataObj.email = $('#inp-email').val().trim();
            paramUserDataObj.password = $('#inp-password').val().trim();
            paramUserDataObj.confirmpassword = $('#inp-confirm-password').val().trim();
            paramUserDataObj.isAccept = $('#check-confirm-accept').is(":checked");
            // cách khác paramUserDataObj.isRemember = $("#ckb-remember-username").val();
        }

        //hàm validate data input
        function validateInput(paramUserDataObj) {
            var vRegexStr = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;

            if (paramUserDataObj.firstname === "") {
                alert("Please enter FirstName");
                $('#inp-first-name').focus();
                return false;
            }

            if (paramUserDataObj.email == "") {
                alert("Please enter Email");
                $('#inp-email').focus();
                return false;
            }

            if (!vRegexStr.test(paramUserDataObj.email)) {
                alert("Invalid email!");
                $('#inp-password').focus();
                return false;
            }

            if (paramUserDataObj.password == "") {
                alert("Please enter PassWord");
                $('#inp-confirm-password').focus();
                return false;
            }

            if (paramUserDataObj.password != paramUserDataObj.confirmpassword) {
                alert("PassWord and Confirm Password do not match");
                $('#inp-password').focus();
                return false;
            }

            if (!paramUserDataObj.isAccept) {
                $("#p-agree-feedback").css("display", "block");
                $('#check-confirm-accept').focus();
                return false;
            }
            else {
                $("#p-agree-feedback").css("display", "none");
            }

            return true;
        }

        //hàm login
        function showUserInfo(paramUserDataObj) {
            console.log("UserName: " + paramUserDataObj.firstname);
            console.log("PW: " + paramUserDataObj.password);

        }
    </script>

</head>

<body>
    <div class="container">
        <!--add type:password
            thêm required vào html để check bắt buôc nhập, tuy nhiên phải ở trong thẻ <form> thì mới có tác dụng -->
        <form id="frm-login">
            <div class="row d-flex align-items-center min-vh-100">
                <div class="col-sm-4 text-center mx-auto my-0 jumbotron">
                    <div class="mb-5">
                        <h3 class="text-center">Sign-up</h3>
                        <p class="hint-text">Please fill in this form to create an account!</p>
                    </div>
                    <div class="form-group">
                        <hr>
                    </div>

                    <div class="form-group">
                        <div class="form-group">
                            <input type="text" class="form-control" id="inp-first-name" placeholder="Username" required>
                        </div>
                        <div class="form-group">
                            <input type="email" name="email" placeholder="email" id="inp-email" class="form-control"
                                required>
                        </div>
                        <div class="form-group">
                            <input name="password" type="password" id="inp-password" placeholder="Password"
                                class="form-control" required>
                        </div>
                        <div class="form-group">
                            <input name="confirm-password" type="password" id="inp-confirm-password"
                                placeholder="Password" class="form-control" required>
                        </div>
                        <div class="form-group">
                            <input type="checkbox" name="rememberusername" id="check-confirm-accept" /> I accept the
                            <a href="#"> Terms of use</a> &amp;
                            <a href="#"> Privacy Policy</a>
                            <p id="p-agree-feedback" class="invalid-feedback">You must accept before submitting</p>
                        </div>
                        <div class="form-group">
                            <button id="btn-sign-up" class="btn btn-log btn-block btn-info">Sign Up</button>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>

</body>

</html>